#pragma vertex
#pragma include "zframework/modules/render/shaders/glsl/libs/Default.vert.glsl"

void main()
{
    defaultMain();
}

#pragma fragment
#pragma include "zframework/modules/render/shaders/glsl/libs/Default.frag.glsl"

uniform vec2 u_delta;
uniform vec4 u_borderColor;

void main()
{
    // hack - ignore bottom part ofthe screen
    if (v_uv.y < 0.085) {
        gl_FragColor = vec4(1.0, 1.0, 1.0, 0.0);
        return;
    }

    float dx = u_delta.x;
    float dy = u_delta.y;
    vec2 dd = vec2(0.69, 0.69);  // diagonal coeff - to make it look more circle-like

    vec3 TL = texture2D(u_texture, v_uv + vec2(-dx,  dy) * dd).rgb;
    vec3 TM = texture2D(u_texture, v_uv + vec2(  0,  dy)).rgb;
    vec3 TR = texture2D(u_texture, v_uv + vec2( dx,  dy) * dd).rgb;

    vec3 ML = texture2D(u_texture, v_uv + vec2(-dx,   0)).rgb;
    vec3 MR = texture2D(u_texture, v_uv + vec2( dx,   0)).rgb;

    vec3 BL = texture2D(u_texture, v_uv + vec2(-dx, -dy) * dd).rgb;
    vec3 BM = texture2D(u_texture, v_uv + vec2(  0, -dy)).rgb;
    vec3 BR = texture2D(u_texture, v_uv + vec2( dx, -dy) * dd).rgb;

    vec3 GradX = -TL + TR - 2.0 * ML + 2.0 * MR - BL + BR;
    vec3 GradY = TL + 2.0 * TM + TR - BL - 2.0 * BM - BR;

    vec4 resultColor = vec4(1.0, 1.0, 1.0, 1.0);
    resultColor.r = length(vec2(GradX.r, GradY.r));
    resultColor.g = length(vec2(GradX.g, GradY.g));
    resultColor.b = length(vec2(GradX.b, GradY.b));
    resultColor = grayscale(resultColor);

    gl_FragColor = vec4(u_borderColor.rgb, u_borderColor.a * resultColor.r);
}
