uniform float u_time;
uniform vec2 u_screenSize;
uniform vec2 u_screenPixelSize;

#pragma include "utils/Math.glsl"

vec2 convertTextureUvToSprite(vec2 textureUv, vec2 topLeft, vec4 orientedSize) {
    mat2 inversedOrientedSize = inverse(mat2(orientedSize));
    vec2 spriteUv = inversedOrientedSize * (textureUv - topLeft);
    
    return spriteUv;
}

vec2 convertSpriteUvToTexture(vec2 spriteUv, vec2 topLeft, vec4 orientedSize) {
    vec2 textureUv = orientedSize.xy * spriteUv.x + orientedSize.zw * spriteUv.y;
    textureUv += topLeft;
    
    return textureUv;
}
